<template>
  <v-data-table
    :headers="headers"
    :items="products"
    :search="search"
    sort-by="precioActual"
    class="elevation-1"
  >

    <template v-slot:top>
      <v-toolbar flat color="white" margin="400px">
        <v-toolbar-title>Lista Productos</v-toolbar-title>
        <v-divider class="mx-4" inset vertical></v-divider>

        <v-text-field
          v-model="search"
          append-icon="mdi-magnify"
          label="Buscar"
          single-line
          hide-details
        ></v-text-field>

        <v-spacer></v-spacer>
        <v-dialog v-model="dialog" max-width="500px">
          <template v-slot:activator="{ on }">
            <v-btn color="#414142" dark class="mb-2" v-on="on">Nuevo Producto</v-btn>
          </template>
          <v-card>
            <v-card-title>
              <span class="headline">{{ formTitle }}</span>
            </v-card-title>

            <v-card-text>
              <v-container>
                <v-row>
                  <v-col cols="12" sm="6" md="4">
                    <v-text-field v-model="newItem.product_name" label="Nombre del Producto"></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="6" md="4">
                    <v-text-field v-model="newItem.cost" type="number" label="Precio Actual"></v-text-field>
                  </v-col>
                  <v-col class="d-flex" cols="12" sm="6">
                    <v-select
                      v-model="newItem.product_category"
                      :items="itemsProductos"
                      label="Categoría"
                    ></v-select>
                  </v-col>
                  <v-col class="d-flex" cols="12" sm="6">
                    <v-select
                      v-model="newItem.unit_measurement"
                      :items="itemsUnit"
                      label="Unidad de Medida"
                    ></v-select>
                  </v-col>
                  <v-col cols="12" sm="6" md="4">
                    <v-text-field v-model="newItem.sku" label="SKU"></v-text-field>
                  </v-col>
                  <picture-input
                    v-model="photoModel"
                    ref="pictureInput"
                    style="width:50%; height:50%;"
                    margin="16"
                    accept="image/jpeg, image/png"
                    size="10"
                    buttonClass="btn"
                    :customStrings="{
                  upload: '<h1>Bummer!</h1>',
                  drag: 'Arrastra una imágen aquí'
                }"
                  ></picture-input>
                </v-row>
              </v-container>
            </v-card-text>

            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="#414142" text @click="close">Cancelar</v-btn>
              <v-btn color="#414142" text @click="save">Guardar</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
    </template>

    <!-- <template v-slot:item.estado>
      <v-switch v-model="switch1" @click="editItem(item)"></v-switch>
    </template>-->
    <template v-slot:item.actions="{ item }">
      <v-icon small class="mr-2" @click="editItem(item)">mdi-pencil</v-icon>
      <v-icon small @click="deleteItem(item)">mdi-delete</v-icon>
    </template>
    <template v-slot:no-data>
      <v-btn color="primary" @click="initialize">Reset</v-btn>
    </template>
  </v-data-table>
</template>


<script>
import PictureInput from "vue-picture-input";
import firebase from "firebase/app";
export default {
  components: {
    PictureInput
  },

  data: () => ({
    dialog: false,
    photoModel: null,
    model: "",
    search: "",
    switch1: true,
    headers: [
      {
        text: "Nombre del Producto",
        align: "start",
        sortable: false,
        value: "name"
      },
      { text: "Precio Actual", value: "precioActual" },
      { text: "Categoria", value: "categoria" },
      // { text: "Estado", value: "estado" },
      { text: "Acciones", value: "actions", sortable: false }
    ],
    products: [],
    datos: [],

    itemsProductos: [
      { text: "Frutas", value: "Frutas" },
      { text: "Verduras y Hortalizas", value: "Verduras y Hortalizas" },
      { text: "Carnicos", value: "Carnicos" },
      {
        text: "Abarrotes/Granos y Semillas",
        value: "Abarrotes/Granos y Semillas"
      }
    ],
    itemsUnit: [
      { text: "Kilogramo", value: "kg" },
      { text: "Pieza", value: "pza" },
      { text: "Manojo", value: "manojo" },
      { text: "Litro", value: "lt" }
    ],
    editedIndex: -1,
    editedItem: {
      name: "",
      precioActual: 0,
      nuevoPrecio: 0,
      categoria: "",
      Estado: true
    },

    newItem: {
      product_name: "",
      cost: "",
      product_category: "",
      state: 1,
      sku: "",
      photo: "",
      unit_measurement: "kg",
      quantity: 1
    },
    defaultItem: {
      name: "",
      precioActual: 0,
      categoria: 0,
      Estado: true
    }
  }),

  computed: {
    formTitle() {
      return this.editedIndex === -1 ? "Nuevo Producto" : "Editar Producto";
    }
  },

  watch: {
    dialog(val) {
      val || this.close();
    }
  },

  created() {
    this.initialize();
  },

  methods: {
    initialize() {
      this.$axios
        .get(`http://${process.env.VUE_APP_API_URL}/api/products`)
        .then(res => {
          res.data.data.forEach(product => {
            console.log(product);
            product.products.forEach(product2 => {
              this.products.push({
                id: product2.id,
                name: product2.info.product_name,
                precioActual: product2.info.cost,
                categoria: product2.info.product_category,
                estado: ""
              });
            });
          });
          console.log(this.datos);
        });
    },

    editItem(item) {
      this.editedIndex = this.products.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialog = true;
    },
    editItem2(item) {
      this.editedIndex = this.products.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialog = true;
    },

    deleteItem(item) {
      console.log(item.id)
      confirm("Desea eliminar este Producto?") &&
       this.$axios
        .post(`http://${process.env.VUE_APP_API_URL}/api/products/delete`, {uid:item.id})
        .then(res => {
          console.log(res);
        });
    },

    close() {
      this.dialog = false;
      setTimeout(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      }, 300);
    },

    save() {
      const photoName = this.newItem.product_name
        .toLowerCase()
        .replace(/ /g, "");
      this.newItem.photo = "products/" + photoName + ".jpg";
      var storageRef = firebase.storage().ref();
      var ref = storageRef.child(this.newItem.photo);
      ref.put(this.$refs.pictureInput.file);

      this.newItem.cost = parseInt(this.newItem.cost)

      let product = {
        jsonProduct: {
          product_name: this.newItem.product_name,
          cost: this.newItem.cost,
          product_category: this.newItem.product_category,
          unit_measurement: this.newItem.unit_measurement,
          quantity: this.newItem.quantity,
          sku: this.newItem.sku,
          state: this.newItem.state,
          photo: this.newItem.photo,
        }
      };

      this.$axios
        .post(`http://${process.env.VUE_APP_API_URL}/api/products`, product)
        .then(res => {
          console.log(res);
        });
      console.log(this.$refs.pictureInput.file);
      this.close();
    }
  }
};
</script>


<style scoped>
.elevation-1 {
  margin: 2%;
  border-radius: 10px;
}
</style>